---
title: A trunk based development work flow
description: "The GitLab workflow facilitates improved team collaboration by accelerating ideas to production with features such as Auto DevOps. Learn more!"
suppress_header: true
canonical_path: "/solutions/gitlab-flow/"
extra_css:
  - open-source.css
extra_js:
  - open-source.js
---

.blank-header
  = image_tag "/images/home/icons-pattern-left.svg", class: "image-border image-border-left", alt: "Gitlab hero border pattern left svg"
  = image_tag "/images/home/icons-pattern-right.svg", class: "image-border image-border-right", alt: "Gitlab hero border pattern right svg"
  .header-content
    -# = image_tag "/images/icons/explore-open-source.svg", alt: "Gitlab explore open source svg"
    %h1 A New Git-Based Workflow
    %p GitLab Flow: A simple, transparent way to work with Git
    = link_to "Try GitLab for Free", "/free-trial/", class: "btn cta-btn accent"
.gitlab-content-container.open-source-content.padding-top50
  .content.tile
    %p
      Git is
      = link_to "open source", "/solutions/open-source/"
      and enables safe, reliable, and fast distributed software development workflows by supporting branches to independently and safely work on features and bug fixes.
    %p
      The GitLab workflow facilitates improved team collaboration by accelerating ideas to production with features such as
      = link_to "Auto DevOps.", "/stages-devops-lifecycle/auto-devops/"
      GitLab Flow unites code version management with project and deployment management tools in order to create the easiest way to work with Git. While development teams can continue to seamlessly use Git, all team members can adopt easy-to-use features to simplify workflows and releases, enabling everyone to participate in a
      = link_to "DevOps", "/topics/devops/"
      transformation as an organization scales.
  .content
    = image_tag "/images/gitlab-flow/gitlab-flow.svg", class: "full-width", alt: "Gitlab flow svg"
  .content.flex-container
    .tile
      %h3 Environment branches for stability
      %p GitLab Flow provisions multiple environments like staging, pre-production, and production by using separate dedicated branches so that commits flow downstream to ensure that everything has been tested on all environments.
    .tile
      %h3 Merge requests for feedback
      %p The GitLab merge request workflow serves as a code review tool, allowing team members to comment in general or on specific lines. If the review reveals shortcomings, anyone can contribute, depending on access level, by either committing to the same branch or forking the branch to create a new merge request.
    .tile
      %h3 Issue tracking for transparency
      %p GitLab Flow integrates the Git workflow with an issue tracking system, so that changes to the code start with an issue where goals are described, helping people keep the scope of a feature branch small.
  .content.quote
    %blockquote.lg
      .blockquote-background#blockquote-background
      .flex-container.flex-column
        %p Adopting GitLab Flow gives software development teams the competitive edge they need in today’s hyper-digitalized and ever-transforming world.
  .content.tweets
    %h2.margin-bottom30 What people are saying
    .flex-container
      %blockquote.twitter-tweet{"data-lang" => "en"}
        %p{:dir => "ltr", :lang => "en"}>
          Getting so used to
          %a{:href => "https://twitter.com/hashtag/gitlab?src=hash&ref_src=twsrc%5Etfw"} #gitlab
          flow that it feels really weird to for once merge your own feature into master
        — Dave V. (@dave_v)
        %a{:href => "https://twitter.com/dave_v/status/991287489649364992?ref_src=twsrc%5Etfw"} May 1, 2018
      %blockquote.twitter-tweet{"data-lang" => "en"}
        %p{:dir => "ltr", :lang => "en"}>
          Gitflow is overly complex, Github-Flow leaves you with unanswered questions about lifecycle. Checkout Gitlab Flow :
          %a{:href => "https://t.co/y4gGZEJllu"} https://t.co/y4gGZEJllu
        — Florent Dupont (@_fdupont)
        %a{:href => "https://twitter.com/_fdupont/status/692709538441609216?ref_src=twsrc%5Etfw"} January 28, 2016
      %blockquote.twitter-tweet{"data-lang" => "en"}
        %p{:dir => "ltr", :lang => "en"}>
          GitLab Flow has some nice alternatives to the typical naming conventions we see for branches.
          %a{:href => "http://t.co/YVNDykRQO4"} http://t.co/YVNDykRQO4
        — emma jane (@emmajanehw)
        %a{:href => "https://twitter.com/emmajanehw/status/611123655775518720?ref_src=twsrc%5Etfw"} June 17, 2015
      %script{:async => "", :charset => "utf-8", :src => "https://platform.twitter.com/widgets.js"}
  .content.cta-tile.tile.flex-container.justify-center.align-center
    = image_tag "/images/logos/git-logo.svg", class: "flex-shrink tile-logo", alt: "Gitlab logo svg"
    %p
      Git has grown to be the most popular version control system for developers — 82 percent of the 100,000 developers who responded to
      %a{ href: "https://insights.stackoverflow.com/survey/2018/#work-version-control", target: "_blank" } Stack Overflow’s 2018 Developer Survey
      are using Git.
  .content.opensource-get-started
    %h2 Get started
    %p.margin-bottom30 Try GitLab Flow to improve collaboration and ship faster
    .flex-container
      %a.tile.tile-animated{ href: "https://about.gitlab.com/resources/whitepaper-moving-to-git/" }
        = image_tag "/images/community/community-contributing.svg", class: "tile-icon margin-bottom30", alt: "Gitlab community contributed svg"
        .tile-content
          %h3 Moving to Git
      %a.tile.tile-animated{ href: "https://docs.gitlab.com/ee/topics/gitlab_flow.html", target: "_blank" }
        = image_tag "/images/downloads/logo.svg", class: "tile-icon margin-bottom30", alt: "Gitlab logo svg"
        .tile-content
          %h3 Introduction to GitLab Flow
    .flex-container
      = link_to "/topics/version-control/what-are-gitlab-flow-best-practices/", class: "tile tile-animated" do
        = image_tag "/images/icons/solid-icons/list-icon.svg", class: "tile-icon margin-bottom30", alt: "Gitlab list icon svg"
        .tile-content
          %h3 11 Rules of GitLab Flow
      = link_to "/blog/2017/03/21/review-apps-continuous-case-study/", class: "tile tile-animated" do
        = image_tag "/images/icons/solid-icons/monitor-icon.svg", class: "tile-icon margin-bottom30", alt: "Gitlab monitor icon svg"
        .tile-content
          %h3 GitLab Flow for Review Apps
